osgGA::SphericalManipulator Class Reference

`#include <SphericalManipulator>`

Inheritance diagram for osgGA::SphericalManipulator:

## Public Types

enum | RotationMode { ELEVATION_HEADING =0 , HEADING , ELEVATION , MAP }
Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }

## Public Member Functions

| SphericalManipulator ()
virtual const char * | className () const
virtual void | setByMatrix (const osg::Matrixd &matrix)
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
virtual osg::Matrixd | getMatrix () const
virtual osg::Matrixd | getInverseMatrix () const
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
virtual float | getFusionDistanceValue () const
virtual void | setNode (osg::Node *)
virtual const osg::Node * | getNode () const
virtual osg::Node * | getNode ()
virtual void | home (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual void | home (double)
virtual void | init (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
void | zoomOn (const osg::BoundingSphere &bound)
virtual bool | handle (const osgGA::GUIEventAdapter &ea, osgGA::GUIActionAdapter &us)
virtual void | computeHomePosition ()
void | computeViewPosition (const osg::BoundingSphere &bound, double &scale, double &distance, osg::Vec3d &center)
void | setCenter (const osg::Vec3d &center)
const osg::Vec3d & | getCenter () const
bool | setDistance (double distance)
double | getDistance () const
double | getHomeDistance () const
void | setHeading (double azimuth)
double | getHeading () const
void | setElevation (double elevation)
double | getElevtion () const
double | getMinimumZoomScale () const
void | setMinimumZoomScale (double minimumZoomScale)
void | setScroolWheelZoomDelta (double zoomDelta)
double | getScroolWheelZoomDelta () const
virtual void | getUsage (osg::ApplicationUsage &usage) const
RotationMode | getRotationMode () const
void | setRotationMode (RotationMode mode)
bool | getAllowThrow () const
void | setAllowThrow (bool allowThrow)
Public Member Functions inherited from osgGA::CameraManipulator
virtual void | setCoordinateFrameCallback (CoordinateFrameCallback *cb)
CoordinateFrameCallback * | getCoordinateFrameCallback ()
const CoordinateFrameCallback * | getCoordinateFrameCallback () const
osg::CoordinateFrame | getCoordinateFrame (const osg::Vec3d &position) const
osg::Vec3d | getSideVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getFrontVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getUpVector (const osg::CoordinateFrame &cf) const
virtual void | updateCamera (osg::Camera &camera)
void | setIntersectTraversalMask (unsigned int mask)
unsigned int | getIntersectTraversalMask () const
virtual void | setHomePosition (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up, bool autoComputeHomePosition=false)
virtual void | getHomePosition (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
virtual void | setAutoComputeHomePosition (bool flag)
bool | getAutoComputeHomePosition () const
virtual void | computeHomePosition (const osg::Camera *camera=NULL, bool useBoundingBox=false)
virtual void | finishAnimation ()
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Member Functions

virtual | ~SphericalManipulator ()
void | flushMouseEventStack ()
void | addMouseEvent (const osgGA::GUIEventAdapter &ea)
bool | calcMovement ()
bool | isMouseMoving ()
Protected Member Functions inherited from osgGA::CameraManipulator
| CameraManipulator ()
| CameraManipulator (const CameraManipulator &mm, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual | ~CameraManipulator ()
std::string | getManipulatorName () const
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< const osgGA::GUIEventAdapter > | _ga_t1
osg::ref_ptr< const osgGA::GUIEventAdapter > | _ga_t0
osg::observer_ptr< osg::Node > | _node
double | _modelScale
double | _minimumZoomScale
bool | _thrown
bool | _allowThrow
double | _delta_frame_time
double | _last_frame_time
RotationMode | _rotationMode
osg::Vec3d | _center
double | _distance
double | _heading
double | _elevation
double | _homeDistance
double | _zoomDelta
Protected Attributes inherited from osgGA::CameraManipulator
unsigned int | _intersectTraversalMask
bool | _autoComputeHomePosition
osg::Vec3d | _homeEye
osg::Vec3d | _homeCenter
osg::Vec3d | _homeUp
osg::ref_ptr< CoordinateFrameCallback > | _coordinateFrameCallback
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Member Enumeration Documentation

## RotationMode

enum osgGA::SphericalManipulator::RotationMode

Enumerator
ELEVATION_HEADING |
HEADING |
ELEVATION |
MAP |

## Constructor & Destructor Documentation

## SphericalManipulator()

osgGA::SphericalManipulator::SphericalManipulator | ( |  | ) |

## ~SphericalManipulator()

virtual osgGA::SphericalManipulator::~SphericalManipulator | ( |  | ) |

protected virtual

## Member Function Documentation

## addMouseEvent()

void osgGA::SphericalManipulator::addMouseEvent | ( | const osgGA::GUIEventAdapter & | ea | ) |

protected

Add the current mouse GUIEvent to internal stack.

## calcMovement()

bool osgGA::SphericalManipulator::calcMovement | ( |  | ) |

protected

For the give mouse movement calculate the movement of the camera. Return true is camera has moved and a redraw is required.

## className()

virtual const char * osgGA::SphericalManipulator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osgGA::CameraManipulator.

## computeHomePosition()

virtual void osgGA::SphericalManipulator::computeHomePosition | ( |  | ) |

virtual

Compute the home position.

## computeViewPosition()

void osgGA::SphericalManipulator::computeViewPosition | ( | const osg::BoundingSphere & | bound,
|  | double & | scale,
|  | double & | distance,
|  | osg::Vec3d & | center )

## flushMouseEventStack()

void osgGA::SphericalManipulator::flushMouseEventStack | ( |  | ) |

protected

Reset the internal GUIEvent stack.

## getAllowThrow()

bool osgGA::SphericalManipulator::getAllowThrow | ( |  | ) | const

inline

Returns true if the camera can be thrown, false otherwise. This defaults to true.

References _allowThrow.

## getCenter()

const osg::Vec3d & osgGA::SphericalManipulator::getCenter | ( |  | ) | const

inline

References _center.

## getDistance()

double osgGA::SphericalManipulator::getDistance | ( |  | ) | const

inline

References _distance.

## getElevtion()

double osgGA::SphericalManipulator::getElevtion | ( |  | ) | const

inline

References _elevation.

## getFusionDistanceMode()

virtual osgUtil::SceneView::FusionDistanceMode osgGA::SphericalManipulator::getFusionDistanceMode | ( |  | ) | const

inline virtual

Get the FusionDistanceMode. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

References osgUtil::SceneView::USE_FUSION_DISTANCE_VALUE.

## getFusionDistanceValue()

virtual float osgGA::SphericalManipulator::getFusionDistanceValue | ( |  | ) | const

inline virtual

Get the FusionDistanceValue. Used by SceneView for setting up stereo convergence.

Reimplemented from osgGA::CameraManipulator.

References _distance.

## getHeading()

double osgGA::SphericalManipulator::getHeading | ( |  | ) | const

inline

References _heading.

## getHomeDistance()

double osgGA::SphericalManipulator::getHomeDistance | ( |  | ) | const

inline

References _homeDistance.

## getInverseMatrix()

virtual osg::Matrixd osgGA::SphericalManipulator::getInverseMatrix | ( |  | ) | const

virtual

get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.

Implements osgGA::CameraManipulator.

## getMatrix()

virtual osg::Matrixd osgGA::SphericalManipulator::getMatrix | ( |  | ) | const

virtual

get the position of the manipulator as 4x4 Matrix.

Implements osgGA::CameraManipulator.

## getMinimumZoomScale()

double osgGA::SphericalManipulator::getMinimumZoomScale | ( |  | ) | const

inline

get the minimum distance (as ratio) the eye point can be zoomed in

References _minimumZoomScale.

## getNode() [1/2]

virtual osg::Node * osgGA::SphericalManipulator::getNode | ( |  | ) |

virtual

Return node if attached.

Reimplemented from osgGA::CameraManipulator.

## getNode() [2/2]

virtual const osg::Node * osgGA::SphericalManipulator::getNode | ( |  | ) | const

virtual

Return node if attached.

Reimplemented from osgGA::CameraManipulator.

## getRotationMode()

RotationMode osgGA::SphericalManipulator::getRotationMode | ( |  | ) | const

inline

References _rotationMode.

## getScroolWheelZoomDelta()

double osgGA::SphericalManipulator::getScroolWheelZoomDelta | ( |  | ) | const

inline

get the mouse scroll wheel zoom delta.

References _zoomDelta.

## getUsage()

virtual void osgGA::SphericalManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const

virtual

Get the keyboard and mouse usage of this manipulator.

Reimplemented from osgGA::EventHandler.

## handle()

virtual bool osgGA::SphericalManipulator::handle | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | us )

virtual

handle events, return true if handled, false otherwise.

Reimplemented from osgGA::CameraManipulator.

## home() [1/2]

virtual void osgGA::SphericalManipulator::home | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | us )

virtual

Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate.

Reimplemented from osgGA::CameraManipulator.

## home() [2/2]

virtual void osgGA::SphericalManipulator::home | ( | double |  | ) |

virtual

Move the camera to the default position. This version does not require GUIEventAdapter and GUIActionAdapter so may be called from somewhere other than a handle() method in GUIEventHandler. Application must be aware of implications.

Reimplemented from osgGA::CameraManipulator.

## init()

virtual void osgGA::SphericalManipulator::init | ( | const osgGA::GUIEventAdapter & | ea,
|  | osgGA::GUIActionAdapter & | us )

virtual

Start/restart the manipulator.

Reimplemented from osgGA::CameraManipulator.

## isMouseMoving()

bool osgGA::SphericalManipulator::isMouseMoving | ( |  | ) |

protected

Check the speed at which the mouse is moving. If speed is below a threshold then return false, otherwise return true.

## setAllowThrow()

void osgGA::SphericalManipulator::setAllowThrow | ( | bool | allowThrow | ) |

inline

Set the 'allow throw' flag. Releasing the mouse button while moving the camera results in a throw.

References _allowThrow.

## setByInverseMatrix()

virtual void osgGA::SphericalManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

References osg::Matrixd::inverse(), and setByMatrix().

## setByMatrix()

virtual void osgGA::SphericalManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) |

virtual

set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

Referenced by setByInverseMatrix().

## setCenter()

void osgGA::SphericalManipulator::setCenter | ( | const osg::Vec3d & | center | ) |

inline

References _center.

## setDistance()

bool osgGA::SphericalManipulator::setDistance | ( | double | distance | ) |

## setElevation()

void osgGA::SphericalManipulator::setElevation | ( | double | elevation | ) |

inline

References _elevation.

## setHeading()

void osgGA::SphericalManipulator::setHeading | ( | double | azimuth | ) |

inline

References _heading.

## setMinimumZoomScale()

void osgGA::SphericalManipulator::setMinimumZoomScale | ( | double | minimumZoomScale | ) |

inline

set the minimum distance (as ratio) the eye point can be zoomed in towards the center before the center is pushed forward.

References _minimumZoomScale.

## setNode()

virtual void osgGA::SphericalManipulator::setNode | ( | osg::Node * |  | ) |

virtual

Attach a node to the manipulator. Automatically detaches previously attached node. setNode(NULL) detaches previously nodes. Is ignored by manipulators which do not require a reference model.

Reimplemented from osgGA::CameraManipulator.

## setRotationMode()

void osgGA::SphericalManipulator::setRotationMode | ( | RotationMode | mode | ) |

## setScroolWheelZoomDelta()

void osgGA::SphericalManipulator::setScroolWheelZoomDelta | ( | double | zoomDelta | ) |

inline

set the mouse scroll wheel zoom delta. Range -1.0 to +1.0, -ve value inverts wheel direction and zero switches off scroll wheel.

References _zoomDelta.

## zoomOn()

void osgGA::SphericalManipulator::zoomOn | ( | const osg::BoundingSphere & | bound | ) |

## Member Data Documentation

## _allowThrow

bool osgGA::SphericalManipulator::_allowThrow

protected

Referenced by getAllowThrow(), and setAllowThrow().

## _center

osg::Vec3d osgGA::SphericalManipulator::_center

protected

Referenced by getCenter(), and setCenter().

## _delta_frame_time

double osgGA::SphericalManipulator::_delta_frame_time

protected

The approximate amount of time it is currently taking to draw a frame. This is used to compute the delta in translation/rotation during a thrown display update. It allows us to match an delta in position/rotation independent of the rendering frame rate.

## _distance

double osgGA::SphericalManipulator::_distance

protected

Referenced by getDistance(), and getFusionDistanceValue().

## _elevation

double osgGA::SphericalManipulator::_elevation

protected

Referenced by getElevtion(), and setElevation().

## _ga_t0

osg::ref_ptr<const osgGA::GUIEventAdapter> osgGA::SphericalManipulator::_ga_t0

protected

## _ga_t1

osg::ref_ptr<const osgGA::GUIEventAdapter> osgGA::SphericalManipulator::_ga_t1

protected

## _heading

double osgGA::SphericalManipulator::_heading

protected

Referenced by getHeading(), and setHeading().

## _homeDistance

double osgGA::SphericalManipulator::_homeDistance

protected

Referenced by getHomeDistance().

## _last_frame_time

double osgGA::SphericalManipulator::_last_frame_time

protected

The time the last frame started. Used when _rate_sensitive is true so that we can match display update rate to rotation/translation rate.

## _minimumZoomScale

double osgGA::SphericalManipulator::_minimumZoomScale

protected

Referenced by getMinimumZoomScale(), and setMinimumZoomScale().

## _modelScale

double osgGA::SphericalManipulator::_modelScale

protected

## _node

osg::observer_ptr<osg::Node> osgGA::SphericalManipulator::_node

protected

## _rotationMode

RotationMode osgGA::SphericalManipulator::_rotationMode

protected

Referenced by getRotationMode().

## _thrown

bool osgGA::SphericalManipulator::_thrown

protected

## _zoomDelta

double osgGA::SphericalManipulator::_zoomDelta

protected

Referenced by getScroolWheelZoomDelta(), and setScroolWheelZoomDelta().

The documentation for this class was generated from the following file:

- SphericalManipulator